#include <fstream.h>
#include <iostream.h>
#include <conio.h>
#include <stdio.h>

void loadtbl(char tblfile[], unsigned char font[][1024]);
int forhtint(unsigned char hexvalue[]);
unsigned long int hextoint(unsigned char num[]);

int main()
    {
    char romfile[13];
    char fontfile[13];
    char outfile[13];
    int width=0;
    int maxwidth;
    int usecount=0;
    int count=0;
    unsigned char readbyte;
    unsigned char font[1][1024];
    unsigned char hexint[8];
    unsigned long int startpos;
    unsigned long int endpos;
    unsigned long int currpos;
    unsigned long int writepos=0;
    int x;
    cout<<"Fixed Length Text Dumper\n";
    cout<<"ROM FILE           :";
    cin>>romfile;
    cout<<"FONT TABLE FILE    :";
    cin>>fontfile;
    cout<<"TEXT OUTPUT FILE   :";
    cin>>outfile;
    cout<<"TEXT START POSITION:";
    cin>>hexint;
    startpos=hextoint(hexint);
    currpos=startpos;
//    cout<<"CURRENT POS:"<<currpos<<"\n";
    cout<<"TEXT END POSITION  :";
    cin>>hexint;
    endpos=hextoint(hexint);
//    cout<<"ENDING POS:"<<endpos<<"\n";
    cout<<"ENTRY WIDTH        :";
    cin>>maxwidth;
    cout<<"COUNT ENTRY?(1=YES):";
    cin>>usecount;
    for(x=0;x<1024;x++)
       {
       font[0][x]=0;
       }
    loadtbl(fontfile,font);
    FILE *read=fopen(romfile,"rb");
    FILE *write=fopen(outfile,"wb");
    while(currpos<=endpos)
       {
       if(usecount==1)
           {
           printf("%5i:",count);
           fseek(write,writepos,SEEK_SET);
           fprintf(write,"%5i",count);
           writepos=writepos+5;
           printf(" (%4x):",count);
           fseek(write,writepos,SEEK_SET);
           fprintf(write," (%4x):",count);
           writepos=writepos+9;
           }
       while(width<maxwidth)
           {
           fseek(read,currpos,SEEK_SET);
           readbyte=fgetc(read);
           readbyte=readbyte*2;
           cout<<font[0][readbyte];
           fseek(write,writepos,SEEK_SET);
           putc((unsigned char)font[0][readbyte],write);
           readbyte++;
           if(font[0][readbyte]>=0x20)
              {
              fseek(write,writepos,SEEK_SET);
              fputc((unsigned char)font[0][readbyte],write);
              writepos++;
              }
           writepos++;
           currpos++;
           width++;
           }
       count++;
       cout<<"\n";
       fseek(write,writepos,SEEK_SET);
       fputc((char)0x0d,write);
       writepos++;
       fseek(write,writepos,SEEK_SET);
       fputc((char)0x0a,write);
       writepos++;
       width=0;
       }
    getch();
    return 0;
    }

void loadtbl(char tblfile[], unsigned char font[][1024])
	{
	FILE *ftable;
	ftable=fopen(tblfile,"rb");
    unsigned int entry, intbyte, quit=0, jpchar=0, x=0, y=0;
	unsigned char readbyte, hexvalue[2];
    unsigned long int filepos=0;
	fseek(ftable,filepos,SEEK_SET);
	readbyte=fgetc(ftable);
	intbyte=readbyte;
        while(quit==0)
		{
        y=0;
        jpchar=0;
		hexvalue[0]=readbyte;
		filepos++;
		fseek(ftable,filepos,SEEK_SET);
		readbyte=fgetc(ftable);
		intbyte=readbyte;
		hexvalue[1]=readbyte;
		entry=forhtint(hexvalue);
		entry=entry*2;
		filepos++;
		filepos++;
		fseek(ftable,filepos,SEEK_SET);
		readbyte=fgetc(ftable);
		intbyte=readbyte;
//        if (intbyte>31)
//             {
//             cout<<readbyte;
//             }
//        else
//             {
//             cout<<intbyte;
//             }
		font[y][entry]=readbyte;
		filepos++;
		if(intbyte>127)
			{
			jpchar=1;
			}
		fseek(ftable,filepos,SEEK_SET);
		readbyte=fgetc(ftable);
		intbyte=readbyte;
		filepos++;
	    if(intbyte>31 || jpchar==1)
			{
			entry++;
			font[y][entry]=readbyte;
            intbyte=readbyte;
			filepos++;
			filepos++;
			}
		else
			{
			filepos++;
			}
		fseek(ftable,filepos,SEEK_SET);
		readbyte=fgetc(ftable);
		intbyte=readbyte;
        while(intbyte==47 || intbyte==42 || intbyte==92 || intbyte==EOF)
			{
            x++;
//            cout<<"\nReading controls...\n";
//            cout<<"Reading byte "<<intbyte<<" from pos "<<filepos<<"...\n";
            if (intbyte==47)
               {
               filepos=filepos+2;
               fseek(ftable,filepos,SEEK_SET);
               readbyte=fgetc(ftable);
               intbyte=readbyte;
               hexvalue[0]=readbyte;
               filepos++;
               fseek(ftable,filepos,SEEK_SET);
               readbyte=fgetc(ftable);
               intbyte=readbyte;
               hexvalue[1]=readbyte;
               entry=forhtint(hexvalue);
               entry=entry*2;
               font[y][entry]=2;
               filepos++;
//               cout<<"End of string is hex "<<entry<<" from pos "<<(filepos-2)<<".\n";
               }
            else if (intbyte==92)
               {
               filepos=filepos+2;
               fseek(ftable,filepos,SEEK_SET);
               readbyte=fgetc(ftable);
               intbyte=readbyte;
               hexvalue[0]=readbyte;
               filepos++;
               fseek(ftable,filepos,SEEK_SET);
               readbyte=fgetc(ftable);
               intbyte=readbyte;
               hexvalue[1]=readbyte;
               entry=forhtint(hexvalue);
               entry=entry*2;
               font[y][entry]=3;
               filepos++;
//               cout<<"Return code is hex "<<entry<<" from pos "<<(filepos-2)<<".\n";
               }
            else if (intbyte==42)
               {
               filepos=filepos+2;
               fseek(ftable,filepos,SEEK_SET);
               readbyte=fgetc(ftable);
               intbyte=readbyte;
               hexvalue[0]=readbyte;
               filepos++;
               fseek(ftable,filepos,SEEK_SET);
               readbyte=fgetc(ftable);
               intbyte=readbyte;
               hexvalue[1]=readbyte;
               entry=forhtint(hexvalue);
               entry=entry*2;
               font[y][entry]=4;
               filepos++;
//               cout<<"Section break is hex "<<entry<<" from pos "<<(filepos-2)<<".\n";
               }
            filepos++;
            filepos++;
            fseek(ftable,filepos,SEEK_SET);
            readbyte=fgetc(ftable);
            intbyte=readbyte;
//            cout<<"Reading byte "<<intbyte<<" from pos "<<filepos<<"!!\n";
            if (intbyte!=47 && intbyte!=42 && intbyte!=92)
               {
               quit=1;
               }
			}
         }
	}


int forhtint(unsigned char hexvalue[])
        {
        unsigned int readbyte;
        unsigned int total;
        readbyte=hexvalue[1];
        if (hexvalue[1]>='0' && hexvalue[1]<='9')
                {
                readbyte=hexvalue[1]-48;
                }
        else if (hexvalue[1]>='a' && hexvalue[1]<= 'f')
                {
                readbyte=hexvalue[1]-'a'+10;
                }
        else
                {
                readbyte=hexvalue[1]-'A'+10;
                }
        total=readbyte;
        if (hexvalue[0]>='0' && hexvalue[0]<='9')
                {
                readbyte=hexvalue[0]-48;
                }
        else if (hexvalue[0]>='a' && hexvalue[0]<= 'f')
                {
                readbyte=hexvalue[0]-'a'+10;
                }
        else
                {
                readbyte=hexvalue[0]-'A'+10;
                }
        total=total+(readbyte*16);
        return total;
        }

unsigned long int hextoint(unsigned char num[])
        {
        char read;
        int x=0, len=0, y, z, w;
        long int total=0;
        y=num[x];
        while (y != 0)
                {
                len++;
                x++;
                y=num[x];
                }
        x=0;
        y=0;
        w=len;
        while (w != 0)
                {
                w--;
                read=num[w];
                if (read >= '0' && read <= '9')
                        {
                        y=num[w]-'0';
                        }
                else if (read >= 'a' && read <= 'f')
                        {
                        y=num[w]-'a'+10;
                        }
                else
                        {
                        y=num[w]-'A'+10;
                        }
                z=0;
                while (z<x)
                        {
                        y=y*16;
                        z++;
                        }
                total=total+y;
                x++;
                }
        return total;
        }
